﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace PHLC
{
    class LoadGUI
    {
        char[] loadChars = { '-', '\\', '|', '/' };
        int cur_char = 0;
        public char LoadChar()
        {
            return loadChars[cur_char];
        }
        public void Next(){
            cur_char++; cur_char = cur_char % 4;
        }
    }

    class StringIO
    {//String ki- és beviteli műveletek
        public static void WriteInPos(string str, int posX, int posY, ConsoleColor Color = ConsoleColor.Gray){
            int posX_old = Console.CursorLeft;
            int posY_old = Console.CursorTop;
            ConsoleColor Color_old = Console.ForegroundColor;
            Console.ForegroundColor = Color;
            Console.SetCursorPosition(posX, posY);
            Console.Write(str);
            Console.ForegroundColor = Color_old;
            Console.SetCursorPosition(posX_old, posY_old);
        }

        public static int CountContains(string str, string contains)
        {//Visszaadja, hogy a stringben a részstring hányszor fordul elő
            int CLength = contains.Length;
            int c = 0;
            int s = 0-CLength;
            while ((s = str.IndexOf(contains, s+CLength)) != -1)
            {
                c++;
            }

            return c;
        }

        public static void WriteColoredMessage(string str, ConsoleColor Color)
        {//Üzenetet a megadott színnel írja ki.
            ConsoleColor Color_old = Console.ForegroundColor;
            Console.ForegroundColor = Color;
            Console.WriteLine(str);
            Console.ForegroundColor = Color_old;
        }

        public static int ReadInteger()
        {//Kivételkezeléssel olvas be egy integert.
            int input;
            bool done = false;
            while(!done){
                try
                {
                    input = int.Parse(Console.ReadLine());
                    return input;
                }
                catch{
                    WriteColoredMessage("Megadott adat hibás! Ellenőrizd és próbáld meg újra!", ConsoleColor.Red);
                }
            }
            return 0;
        }

        public static string ReadThreadUrl()
        {//Ellenőrzött PH!-topik beolvasása
            bool correct = false;
            string input;
            do
            {

                input = Console.ReadLine().ToLower();
                if (Regex.IsMatch(input, "(http://)?(www.)?prohardver.hu/tema/\\S+/?"))
                {
                    int len = input.Length;
                    if (input.Substring(len - 2, 1) == "/") input = input.Substring(0, input.Length - 1);
                    if (input.Substring(0, 7) != "http://") input = "http://" + input;
                    correct = true;
                }
                else
                {
                    WriteColoredMessage("A megadott URL hibás. Kérlek ellenőrizd és add meg újra!", ConsoleColor.Red);
                }
                
            } while (!correct);
            return input;
        }
    }

    class Date
    {//Dátum-idő művletek
        private byte[] monthLength = { 31, 28 /* 28(d)/29 */ , 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

        public bool CheckDate(ushort year, byte month, byte day)
        {//Beolvasott dátumok ellenőrzése
            if (year < 2000 || year > DateTime.Now.Year)
            {
                return false;
            }

            if (month <= 0 || month > 12)
            {
                return false;
            }

            if (day <= 0 && day > monthLength[month-1]+((month == 2 && year%4 == 0)?1:0))
            {
                return false;
            }

            return true;
        }
    }
    class Collector
    {//A program fő műveletei

        //Deklarálások
        //Konstansok
        private const string message_head = "head flc";
        private const string text_sign = "<p class=\"sign\">";
        private const string text_end = "</div>\n  </div>\n\n";
        private const string text_head = "<p class=\"mgt0\">";
        private const string forum_end = "<div id=\"navi_btm\" class=\"pnavi fnavi\"><div class=\"inr flc\">";


        //Változók
        private StreamWriter SW;
        private ushort  start_year;
        private byte    start_month;
        private byte    start_day;

        private ushort  end_year;
        private byte    end_month;
        private byte    end_day;

        private DateTime DT_start, DT_end;

        private LoadGUI loadgui = new LoadGUI();
        private LoadGUI loadgui2 = new LoadGUI();

        private string thread_url;

        private int count = 0;
        private int pages = 0;


        public void ShowHead()
        {//Fejléc rajzlása
            int cursorX = Console.CursorLeft;
            int cursorY = Console.CursorTop;
            Console.ForegroundColor = ConsoleColor.White;
            Console.SetCursorPosition(0, 0);
            Console.Write("{0,80}", "");
            Console.SetCursorPosition(0, 3);
            Console.Write("{0,80}", "");

            Console.BackgroundColor = ConsoleColor.Gray;
            Console.SetCursorPosition(0, 2);
            Console.Write("{0,80}", "");
            Console.SetCursorPosition(0, 2);
            Console.ForegroundColor = ConsoleColor.Black;
            Console.Write("Bejárt oldalak: {0,6} | Találatok: {1,6}", pages, count);

            Console.ForegroundColor = ConsoleColor.White;
            Console.BackgroundColor = ConsoleColor.DarkGray;
            Console.SetCursorPosition(0, 1);
            Console.Write("{0,80}", "");
            Console.SetCursorPosition(0, 1);
            Console.Write("Reactorx2(LW)'s PH! Link Collector v 1.0");
            Console.SetCursorPosition(0, 3);

            Console.BackgroundColor = ConsoleColor.Black;
            StringIO.WriteInPos(loadgui.LoadChar().ToString(), 78, 0, ConsoleColor.Yellow);
            StringIO.WriteInPos(loadgui2.LoadChar().ToString(), 79, 0, ConsoleColor.Green);
            Console.SetCursorPosition(cursorX, cursorY);
        }

        public void cClear()
        {//Konzolképernyő tisztítása a fejléc kirajzolásával
            Console.BackgroundColor = ConsoleColor.Black;
            Console.Clear();
            ShowHead();
        }

        public void init()
        {//Beolvasás a lefutás megkezdéséhez
            StringIO SIO = new StringIO();
            Date D = new Date();

            //Beolvasás
            Console.SetCursorPosition(0, 4);
            Console.WriteLine("Add meg a PH! téma URL címét (pl. prohardver.hu/tema/temacime):");
            thread_url = StringIO.ReadThreadUrl();

            bool start_correct = false;
            bool end_correct = false;

            do
            {
                Console.WriteLine("Add meg a kezdési évet:");
                start_year = (ushort)StringIO.ReadInteger();

                Console.WriteLine("Add meg a kezdési hónapot:");
                start_month = (byte)StringIO.ReadInteger();

                Console.WriteLine("Add meg a kezdési napot:");
                start_day = (byte)StringIO.ReadInteger();
                
                if (D.CheckDate(start_year, start_month, start_day))
                {
                    start_correct = true;
                }
                else
                {
                    StringIO.WriteColoredMessage("A megadott dátum hibás! Kérlek ellenőrizd és add meg újra!", ConsoleColor.Red);
                }

            } while (!start_correct);

            do
            {

                Console.WriteLine("Add meg az utolsó évet:");
                end_year = (ushort)StringIO.ReadInteger();

                Console.WriteLine("Add meg az utolsó hónapot:");
                end_month = (byte)StringIO.ReadInteger();

                Console.WriteLine("Add meg az utolsó napot:");
                end_day = (byte)StringIO.ReadInteger();

                if (D.CheckDate(end_year, end_month, end_day))
                {
                    end_correct = true;
                }
                else
                {
                    StringIO.WriteColoredMessage("A megadott dátum hibás! Kérlek ellenőrizd és add meg újra!", ConsoleColor.Red);
                }

            } while (!end_correct);
             
            DT_start = new DateTime(start_year, start_month, start_day);
            DT_end = new DateTime(end_year, end_month, end_day);

            SW = new StreamWriter("results_" + thread_url.Substring(thread_url.LastIndexOf('/')+1) + "_" + start_year.ToString() + start_month.ToString() + start_day.ToString() + "-" + end_year.ToString() + end_month.ToString() + end_day.ToString() + ".txt");
        }

        public string GetSite(string strURL)
        {//Weblap forrásának lekérése
            try
            {
                WebRequest myWebRequest = WebRequest.Create(strURL);
                WebResponse myWebResponse = myWebRequest.GetResponse();
                Stream ReceiveStream = myWebResponse.GetResponseStream();
                Encoding encode = System.Text.Encoding.GetEncoding("utf-8");
                StreamReader readStream = new StreamReader(ReceiveStream, encode);
                string source = readStream.ReadToEnd();
                source = source.Replace("src=\"/dl/upc/", "http://prohardver.hu/dl/upc/");
                return source;
            }
            catch
            {
                return "~error~";
            }
        }

        public void Execute()
        {//Futtatás

            //Előkészítés, deklaráció
            string response, rec_date;
            int offset = 0;
            cClear();
            Console.SetCursorPosition(0, 4);
            Console.WriteLine(" # Bejárás megkezdése.");
            Console.WriteLine(" # Feldolgozás alatt: -.");


            SW.WriteLine(":: Média és linkek gyűjtésének eredménye | PH! Link Collector v1.0");
            SW.WriteLine("<-- Paraméterek");
            SW.WriteLine("\tTéma: {0}", thread_url);
            SW.WriteLine("\tKezdési dátum: {0}-{1}-{2}", start_year, start_month, start_day);
            SW.WriteLine("\tUtolsó dátum: {0}-{1}-{2}", end_year, end_month, end_day);
            SW.WriteLine("Paraméterek -->");
            SW.WriteLine("<-- Eredmények");
            SW.WriteLine("{0,20} | {1,10} | {2,14} | {3}", "Felhasználónév", "HSZ. szám", "Dátum", "URL");
            do
            {
                StringIO.WriteInPos("hsz_" + (offset + 1) + "-" + (offset + 200) + ".html" + "\t", 22, 5);
                pages++;
                loadgui.Next();
                ShowHead();
                
                response = GetSite(thread_url + "/hsz_" + (offset + 1) + "-" + (offset + 200) + ".html");
                if (response == "~error~") { StringIO.WriteColoredMessage("A megadott téma nem elérhető vagy nem létezik!", ConsoleColor.Red); break; }
                offset += 200;
                
                // <-- Művelet

                int io_begin = response.IndexOf(message_head);
                int io_time = response.IndexOf("<li class=\"time\">", io_begin) + 17;
                int lio_begin = response.LastIndexOf(message_head);
                int lio_time = response.IndexOf("<li class=\"time\">", lio_begin)+17;

                rec_date = response.Substring(io_time, 10);
                DateTime DT_S = new DateTime(int.Parse(rec_date.Substring(0, 4)), int.Parse(rec_date.Substring(5, 2)), int.Parse(rec_date.Substring(8, 2)));

                rec_date = response.Substring(lio_time, 10);
                DateTime DT_L = new DateTime(int.Parse(rec_date.Substring(0, 4)), int.Parse(rec_date.Substring(5,2)), int.Parse(rec_date.Substring(8, 2)));

                if (DateTime.Compare(DT_L, DT_start) < 0) continue;
                if (DateTime.Compare(DT_S, DT_end) > 0) break;

                //Feldolgozás
                ChkPage(response);

                // Művelet vége -->
            }
            while (!response.Contains("arr-next-gray.gif"));

            SW.WriteLine("Eredmények -->");
            SW.Close();

            StringIO.WriteInPos("-\t\t\t\t\t", 22, 5);
            StringIO.WriteColoredMessage(" # A bejárás véget ért.", ConsoleColor.Green);
        }

        public void ChkPage(string response)
        {//Jelenlegi oldal átfésülése és találatok rögzítése
            int
                lio_forumend = response.LastIndexOf(forum_end),
                io_link = response.IndexOf(text_head),
                io_link_end = io_link,
                io_le_space,
                io_le_quot,
                link_len = 0,

                io_rec_date_start,
                io_rec_date_end,
                io_rec_onum_start,
                io_rec_onum_end,
                io_rec_nick_start,
                io_rec_nick_end;
            string rec_date, rec_nick, rec_link, rec_onum;

            int lio_texthead, lio_textend, lio_signhead;
            do
            {
                if (io_link == -1) break;
                io_link = response.IndexOf("http://", io_link + 1);
                lio_texthead = response.LastIndexOf(text_head, io_link);
                lio_textend = response.LastIndexOf(text_end, io_link);
                lio_signhead = response.LastIndexOf(text_sign, io_link);
                io_le_space = response.IndexOf(' ', io_link);
                io_le_quot = response.IndexOf('"', io_link);
                io_link_end = (io_le_space < io_le_quot) ? io_le_space : io_le_quot;
                link_len = io_link_end - io_link;
                if (io_link > lio_forumend)
                {
                    break;
                }
                if (lio_texthead > lio_textend && lio_signhead<lio_texthead)
                {
                    rec_link = response.Substring(io_link, link_len);

                    io_rec_onum_start = response.LastIndexOf("<p>(<a name=\"msg", io_link)+16;
                    io_rec_onum_end = response.IndexOf('"', io_rec_onum_start);
                    rec_onum = response.Substring(io_rec_onum_start, io_rec_onum_end - io_rec_onum_start);

                    io_rec_date_start = response.LastIndexOf("<li class=\"time\">", io_link) + 17;
                    io_rec_date_end = response.IndexOf(' ', io_rec_date_start);
                    rec_date = response.Substring(io_rec_date_start, io_rec_date_end - io_rec_date_start);

                    io_rec_nick_start = response.LastIndexOf(") <a href=\"/tag/", io_link) + 16;
                    io_rec_nick_end = response.IndexOf(".html", io_rec_nick_start);
                    rec_nick = response.Substring(io_rec_nick_start, io_rec_nick_end - io_rec_nick_start);

                    count++;
                    loadgui2.Next();
                    ShowHead();
                    SW.WriteLine("{0,20} | {1,10} | {2,14} | {3}", rec_nick, rec_onum, rec_date, rec_link);
                    io_link = io_link + link_len;
                } 
                else
                {
                    io_link++;
                    continue;
                } 

            } while (true);
        }
    }

    class Program{
        static void Main(string[] args)
        {//Program
            Collector LC = new Collector();
            LC.cClear();
            LC.init();
            LC.Execute();
            StringIO.WriteColoredMessage(" # Bezáráshoz nyomj le egy gombot!", ConsoleColor.DarkGray);
            Console.ReadKey();
        }
    }
}
